diff --git a/arch/arm/mach-sa1100/ipaq-sleeve-bus.c b/arch/arm/mach-sa1100/ipaq-sleeve-bus.c
new file mode 100644
index 000000000000..31299589d4a9
--- /dev/null
+++ b/arch/arm/mach-sa1100/ipaq-sleeve-bus.c
@@ -0,0 +1,141 @@
+#include <linux/ipaq-sleeve.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+
+#define to_ipaq_option_driver(x) \
+	container_of(x, struct ipaq_option_driver, driver)
+
+static ssize_t vendor_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+	return snprintf(buf, PAGE_SIZE, "%04x\n", idev->id.vendor);
+}
+static DEVICE_ATTR_RO(vendor);
+
+static ssize_t device_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+	return snprintf(buf, PAGE_SIZE, "%04x\n", idev->id.device);
+}
+static DEVICE_ATTR_RO(device);
+
+static ssize_t description_show(struct device *dev, struct device_attribute *attr, char *buf)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+	return snprintf(buf, PAGE_SIZE, "%s\n", idev->description);
+}
+static DEVICE_ATTR_RO(description);
+
+static struct attribute *ipaq_option_sleeve_attrs[] = {
+	&dev_attr_description.attr,
+	&dev_attr_device.attr,
+	&dev_attr_vendor.attr,
+	NULL,
+};
+
+static const struct attribute_group ipaq_option_sleeve_dev_group = {
+	.attrs = ipaq_option_sleeve_attrs,
+};
+
+static const struct attribute_group *ipaq_option_sleeve_dev_groups[] = {
+	&ipaq_option_sleeve_dev_group,
+	NULL,
+};
+
+static int ipaq_option_sleeve_match(struct device *dev, struct device_driver *drv)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+	struct ipaq_option_driver *idrv = to_ipaq_option_driver(drv);
+	const struct ipaq_option_id *id;
+
+	for (id = idrv->id_table; id->vendor || id->device; id++)
+		if (id->vendor == idev->id.vendor &&
+		    id->device == idev->id.device)
+			return 1;
+
+	return 0;
+}
+
+static int ipaq_option_sleeve_uevent(struct device *dev, struct kobj_uevent_env *env)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+
+	if (!dev)
+		return -ENODEV;
+
+	if (add_uevent_var(env, "DESCRIPTION=%s", idev->description) ||
+	    add_uevent_var(env, "MODALIAS=ipaq:v%04Xd%04X",
+			   idev->id.vendor, idev->id.device))
+		return -ENOMEM;
+
+	return 0;
+}
+
+struct bus_type ipaq_option_sleeve_bus = {
+	.name = "ipaq-sleeve",
+	.dev_groups = ipaq_option_sleeve_dev_groups,
+	.match = ipaq_option_sleeve_match,
+	.uevent = ipaq_option_sleeve_uevent,
+};
+EXPORT_SYMBOL_GPL(ipaq_option_sleeve_bus);
+
+static void ipaq_option_release(struct device *dev)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+
+	kfree(idev->description);
+	kfree(idev);
+}
+
+int ipaq_option_device_add(struct device *parent, struct ipaq_option_id id,
+	const char *description)
+{
+	struct ipaq_option_device *idev;
+
+	idev = kzalloc(sizeof(*idev), GFP_KERNEL);
+	if (!idev)
+		return -ENOMEM;
+
+	idev->description = kstrdup(description, GFP_KERNEL);
+	if (!idev->description) {
+		kfree(idev);
+		return -ENOMEM;
+	}
+
+	idev->id = id;
+	device_initialize(&idev->dev);
+	dev_set_name(&idev->dev, "sleeve");
+	idev->dev.parent = parent;
+	idev->dev.release = ipaq_option_release;
+	idev->dev.bus = &ipaq_option_sleeve_bus;
+
+	return device_add(&idev->dev);
+}
+EXPORT_SYMBOL_GPL(ipaq_option_device_add);
+
+static int ipaq_option_device_remove(struct device *dev, void *data)
+{
+	device_unregister(dev);
+	return 0;
+}
+
+void ipaq_option_device_del(void)
+{
+	bus_for_each_dev(&ipaq_option_sleeve_bus, NULL, NULL,
+			 ipaq_option_device_remove);
+}
+EXPORT_SYMBOL_GPL(ipaq_option_device_del);
+
+static int ipaq_option_sleeve_init(void)
+{
+	return bus_register(&ipaq_option_sleeve_bus);
+}
+core_initcall(ipaq_option_sleeve_init);
+
+static void ipaq_option_sleeve_exit(void)
+{
+	bus_unregister(&ipaq_option_sleeve_bus);
+}
+module_exit(ipaq_option_sleeve_exit);
+
+MODULE_LICENSE("GPL");
diff --git a/arch/arm/mach-sa1100/ipaq-sleeve-cf.c b/arch/arm/mach-sa1100/ipaq-sleeve-cf.c
new file mode 100644
index 000000000000..8f0b8ae8b75c
--- /dev/null
+++ b/arch/arm/mach-sa1100/ipaq-sleeve-cf.c
@@ -0,0 +1,70 @@
+#include <linux/ipaq-sleeve.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+
+struct ipaq_sleeve_cf_data {
+	struct platform_device *skt;
+};
+
+static int ipaq_sleeve_cf_probe(struct device *dev)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+	struct ipaq_sleeve_cf_data *cf;
+	struct platform_device_info pinfo = {
+		.parent = dev,
+		.name = "sa11x0-pcmcia",
+		.id = 0,
+		.data = &idev->id,
+		.size_data = sizeof(idev->id),
+	};
+
+	cf = devm_kzalloc(dev, sizeof(*cf), GFP_KERNEL);
+	if (!cf)
+		return -ENOMEM;
+
+	cf->skt = platform_device_register_full(&pinfo);
+	if (IS_ERR(cf->skt)) {
+		dev_err(dev, "unable to register pcmcia device: %ld\n",
+			PTR_ERR(cf->skt));
+		return PTR_ERR(cf->skt);
+	}
+
+	dev_set_drvdata(dev, cf);
+
+	return 0;
+}
+
+static int ipaq_sleeve_cf_remove(struct device *dev)
+{
+	struct ipaq_sleeve_cf_data *cf = dev_get_drvdata(dev);
+
+	platform_device_unregister(cf->skt);
+
+	return 0;
+}
+
+static const struct ipaq_option_id ipaq_sleeve_cf_ids[] = {
+	{	/* Compaq CompactFlash sleeve */
+		.vendor = 0x1125,
+		.device = 0xcf11,
+	}, {	/* Compaq single PCMCIA sleeve */
+		.vendor = 0x1125,
+		.device = 0xd7c3,
+	}, { },
+};
+
+static struct ipaq_option_driver ipaq_sleeve_cf = {
+	.id_table = ipaq_sleeve_cf_ids,
+	.driver = {
+		.name = "ipaq-sleeve-cf",
+		.probe = ipaq_sleeve_cf_probe,
+		.remove = ipaq_sleeve_cf_remove,
+	},
+};
+
+module_driver(ipaq_sleeve_cf, ipaq_option_driver_register,
+	ipaq_option_driver_unregister);
+
+MODULE_LICENSE("GPL");
+MODULE_DEVICE_TABLE(ipaq, ipaq_sleeve_cf_ids);
diff --git a/arch/arm/mach-sa1100/ipaq-sleeve-dual.c b/arch/arm/mach-sa1100/ipaq-sleeve-dual.c
new file mode 100644
index 000000000000..dd4c3f756885
--- /dev/null
+++ b/arch/arm/mach-sa1100/ipaq-sleeve-dual.c
@@ -0,0 +1,68 @@
+#include <linux/ipaq-sleeve.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+
+struct ipaq_sleeve_dual_data {
+	struct platform_device *skt;
+};
+
+static int ipaq_sleeve_dual_probe(struct device *dev)
+{
+	struct ipaq_option_device *idev = to_ipaq_option_device(dev);
+	struct ipaq_sleeve_dual_data *cf;
+	struct platform_device_info pinfo = {
+		.parent = dev,
+		.name = "sa11x0-pcmcia",
+		.id = -1,
+	};
+
+	cf = devm_kzalloc(dev, sizeof(*cf), GFP_KERNEL);
+	if (!cf)
+		return -ENOMEM;
+
+	pinfo.data = &idev->id;
+	pinfo.size_data = sizeof(idev->id);
+
+	cf->skt = platform_device_register_full(&pinfo);
+	if (IS_ERR(cf->skt)) {
+		dev_err(dev, "unable to register pcmcia device: %ld\n",
+			PTR_ERR(cf->skt));
+		return PTR_ERR(cf->skt);
+	}
+
+	dev_set_drvdata(dev, cf);
+
+	return 0;
+}
+
+static int ipaq_sleeve_dual_remove(struct device *dev)
+{
+	struct ipaq_sleeve_dual_data *cf = dev_get_drvdata(dev);
+
+	platform_device_unregister(cf->skt);
+
+	return 0;
+}
+
+static const struct ipaq_option_id ipaq_sleeve_dual_ids[] = {
+	{	/* Compaq dual PCMCIA sleeve */
+		.vendor = 0x1125,
+		.device = 0x0001,
+	}, { },
+};
+
+static struct ipaq_option_driver ipaq_sleeve_dual = {
+	.id_table = ipaq_sleeve_dual_ids,
+	.driver = {
+		.name = "ipaq-sleeve-dual",
+		.probe = ipaq_sleeve_dual_probe,
+		.remove = ipaq_sleeve_dual_remove,
+	},
+};
+
+module_driver(ipaq_sleeve_dual, ipaq_option_driver_register,
+	ipaq_option_driver_unregister);
+
+MODULE_LICENSE("GPL");
+MODULE_DEVICE_TABLE(ipaq, ipaq_sleeve_dual_ids);
diff --git a/arch/arm/mach-sa1100/neponset.c b/arch/arm/mach-sa1100/neponset.c
index 0ef0ebbf31ac..186da44d554e 100644
--- a/arch/arm/mach-sa1100/neponset.c
+++ b/arch/arm/mach-sa1100/neponset.c
@@ -2,10 +2,13 @@
 /*
  * linux/arch/arm/mach-sa1100/neponset.c
  */
+#include <linux/clk-provider.h>
+#include <linux/clkdev.h>
 #include <linux/err.h>
 #include <linux/gpio/driver.h>
 #include <linux/gpio/gpio-reg.h>
 #include <linux/gpio/machine.h>
+#include <linux/gpio/consumer.h>
 #include <linux/init.h>
 #include <linux/ioport.h>
 #include <linux/irq.h>
@@ -24,7 +27,6 @@
 
 #include <mach/hardware.h>
 #include <mach/assabet.h>
-#include <mach/neponset.h>
 #include <mach/irqs.h>
 
 #define NEP_IRQ_SMC91X	0
@@ -47,6 +49,7 @@
 #define IRR_USAR	(1 << 1)
 #define IRR_SA1111	(1 << 2)
 
+#define NCR_GP01_OFF	BIT(0)
 #define NCR_NGPIO	7
 #define MDM_CTL0_NGPIO	4
 #define MDM_CTL1_NGPIO	6
@@ -75,10 +78,15 @@ static const char *neponset_aud_names[] = {
 
 struct neponset_drvdata {
 	void __iomem *base;
+	struct device *dev;
 	struct platform_device *sa1111;
 	struct platform_device *smc91x;
 	unsigned irq_base;
+	struct irq_domain *irq_domain;
 	struct gpio_chip *gpio[4];
+	struct clk_hw *enet_osc_ck;
+	struct clk_hw *enet_osc_gate;
+	struct clk_lookup *enet_osc_cl;
 };
 
 static struct gpiod_lookup_table neponset_uart1_gpio_table = {
@@ -120,17 +128,17 @@ static struct gpiod_lookup_table neponset_pcmcia_table = {
 
 static struct neponset_drvdata *nep;
 
-void neponset_ncr_frob(unsigned int mask, unsigned int val)
+static void neponset_handle_irq(struct neponset_drvdata *d, int irq)
 {
-	struct neponset_drvdata *n = nep;
-	unsigned long m = mask, v = val;
+	int virq = irq_find_mapping(d->irq_domain, irq);
 
-	if (nep)
-		n->gpio[0]->set_multiple(n->gpio[0], &m, &v);
-	else
-		WARN(1, "nep unset\n");
+	if (!virq) {
+		dev_warn(d->dev, "spurious irq detected, hwirq %d irq %d\n",
+			 irq, virq);
+		return;
+	}
+	generic_handle_irq(virq);
 }
-EXPORT_SYMBOL(neponset_ncr_frob);
 
 /*
  * Install handler for Neponset IRQ.  Note that we have to loop here
@@ -141,12 +149,11 @@ EXPORT_SYMBOL(neponset_ncr_frob);
 static void neponset_irq_handler(struct irq_desc *desc)
 {
 	struct neponset_drvdata *d = irq_desc_get_handler_data(desc);
-	unsigned int irr;
+	unsigned long irr;
+	int irq;
 
 	while (1) {
-		/*
-		 * Acknowledge the parent IRQ.
-		 */
+		// Acknowledge the parent IRQ before reading the IRR.
 		desc->irq_data.chip->irq_ack(&desc->irq_data);
 
 		/*
@@ -157,36 +164,12 @@ static void neponset_irq_handler(struct irq_desc *desc)
 		irr = readb_relaxed(d->base + IRR);
 		irr ^= IRR_ETHERNET | IRR_USAR;
 
+		// If no pending interrupts, then we're done.
 		if ((irr & (IRR_ETHERNET | IRR_USAR | IRR_SA1111)) == 0)
 			break;
 
-		/*
-		 * Since there is no individual mask, we have to
-		 * mask the parent IRQ.  This is safe, since we'll
-		 * recheck the register for any pending IRQs.
-		 */
-		if (irr & (IRR_ETHERNET | IRR_USAR)) {
-			desc->irq_data.chip->irq_mask(&desc->irq_data);
-
-			/*
-			 * Ack the interrupt now to prevent re-entering
-			 * this neponset handler.  Again, this is safe
-			 * since we'll check the IRR register prior to
-			 * leaving.
-			 */
-			desc->irq_data.chip->irq_ack(&desc->irq_data);
-
-			if (irr & IRR_ETHERNET)
-				generic_handle_irq(d->irq_base + NEP_IRQ_SMC91X);
-
-			if (irr & IRR_USAR)
-				generic_handle_irq(d->irq_base + NEP_IRQ_USAR);
-
-			desc->irq_data.chip->irq_unmask(&desc->irq_data);
-		}
-
-		if (irr & IRR_SA1111)
-			generic_handle_irq(d->irq_base + NEP_IRQ_SA1111);
+		for_each_set_bit(irq, &irr, 8)
+			neponset_handle_irq(d, irq);
 	}
 }
 
@@ -202,6 +185,44 @@ static struct irq_chip nochip = {
 	.irq_unmask = nochip_noop,
 };
 
+static int neponset_irqdomain_map(struct irq_domain *d, unsigned int irq,
+	irq_hw_number_t hwirq)
+{
+	irq_set_chip_and_handler(irq, &nochip, handle_simple_irq);
+	irq_clear_status_flags(irq, IRQ_NOREQUEST);
+
+	return 0;
+}
+
+static const struct irq_domain_ops nep_irqdomain_ops = {
+	.map = neponset_irqdomain_map,
+	.xlate = irq_domain_xlate_onetwocell,
+};
+
+static int neponset_init_irr(struct device *dev, struct neponset_drvdata *d, int irq)
+{
+	int ret;
+
+	ret = irq_alloc_descs(-1, IRQ_BOARD_START, NEP_IRQ_NR, -1);
+	if (ret <= 0) {
+		dev_err(dev, "unable to allocate %u irqs: %d\n",
+			NEP_IRQ_NR, ret);
+		if (ret == 0)
+			ret = -ENOMEM;
+		return ret;
+	}
+
+	d->irq_base = ret;
+
+	d->irq_domain = irq_domain_add_simple(NULL, NEP_IRQ_NR, ret,
+					      &nep_irqdomain_ops, d);
+
+	irq_set_irq_type(irq, IRQ_TYPE_EDGE_RISING);
+	irq_set_chained_handler_and_data(irq, neponset_irq_handler, d);
+
+	return 0;
+}
+
 static int neponset_init_gpio(struct gpio_chip **gcp,
 	struct device *dev, const char *label, void __iomem *reg,
 	unsigned num, bool in, const char *const * names)
@@ -218,6 +239,38 @@ static int neponset_init_gpio(struct gpio_chip **gcp,
 	return 0;
 }
 
+static int neponset_init_enet(struct device *dev, struct neponset_drvdata *d)
+{
+	struct gpio_desc *gpio;
+	int ret;
+
+	d->enet_osc_ck = clk_hw_register_fixed_rate(dev, "nep_enet_osc",
+						    NULL, 0, 20000000);
+	if (IS_ERR(d->enet_osc_ck))
+		return PTR_ERR(d->enet_osc_ck);
+
+	gpio = gpio_to_desc(d->gpio[0]->base + 3);
+	d->enet_osc_gate = clk_hw_register_gpio_gate(dev, "nep_enet_gate",
+						     "nep_enet_osc", gpio, 0);
+	if (IS_ERR(d->enet_osc_gate)) {
+		ret = PTR_ERR(d->enet_osc_gate);
+		goto err;
+	}
+
+	d->enet_osc_cl = clkdev_hw_create(d->enet_osc_gate, NULL, "smc91x.0");
+	if (!d->enet_osc_cl) {
+		ret = -ENOMEM;
+		goto err;
+	}
+
+	return 0;
+
+err:
+	if (d->enet_osc_ck)
+		clk_hw_unregister_fixed_rate(d->enet_osc_ck);
+	return ret;
+}
+
 static struct sa1111_platform_data sa1111_info = {
 	.disable_devs	= SA1111_DEVID_PS2_MSE,
 };
@@ -266,26 +319,28 @@ static int neponset_probe(struct platform_device *dev)
 
 	irq = ret = platform_get_irq(dev, 0);
 	if (ret < 0)
-		goto err_alloc;
+		goto err;
 
 	nep_res = platform_get_resource(dev, IORESOURCE_MEM, 0);
 	smc91x_res = platform_get_resource(dev, IORESOURCE_MEM, 1);
 	sa1111_res = platform_get_resource(dev, IORESOURCE_MEM, 2);
 	if (!nep_res || !smc91x_res || !sa1111_res) {
 		ret = -ENXIO;
-		goto err_alloc;
+		goto err;
 	}
 
-	d = kzalloc(sizeof(*d), GFP_KERNEL);
+	d = devm_kzalloc(&dev->dev, sizeof(*d), GFP_KERNEL);
 	if (!d) {
 		ret = -ENOMEM;
-		goto err_alloc;
+		goto err;
 	}
 
+	d->dev = &dev->dev;
+
 	d->base = ioremap(nep_res->start, SZ_4K);
 	if (!d->base) {
 		ret = -ENOMEM;
-		goto err_ioremap;
+		goto err;
 	}
 
 	if (readb_relaxed(d->base + WHOAMI) != 0x11) {
@@ -295,27 +350,9 @@ static int neponset_probe(struct platform_device *dev)
 		goto err_id;
 	}
 
-	ret = irq_alloc_descs(-1, IRQ_BOARD_START, NEP_IRQ_NR, -1);
-	if (ret <= 0) {
-		dev_err(&dev->dev, "unable to allocate %u irqs: %d\n",
-			NEP_IRQ_NR, ret);
-		if (ret == 0)
-			ret = -ENOMEM;
+	ret = neponset_init_irr(&dev->dev, d, irq);
+	if (ret < 0)
 		goto err_irq_alloc;
-	}
-
-	d->irq_base = ret;
-
-	irq_set_chip_and_handler(d->irq_base + NEP_IRQ_SMC91X, &nochip,
-		handle_simple_irq);
-	irq_clear_status_flags(d->irq_base + NEP_IRQ_SMC91X, IRQ_NOREQUEST | IRQ_NOPROBE);
-	irq_set_chip_and_handler(d->irq_base + NEP_IRQ_USAR, &nochip,
-		handle_simple_irq);
-	irq_clear_status_flags(d->irq_base + NEP_IRQ_USAR, IRQ_NOREQUEST | IRQ_NOPROBE);
-	irq_set_chip(d->irq_base + NEP_IRQ_SA1111, &nochip);
-
-	irq_set_irq_type(irq, IRQ_TYPE_EDGE_RISING);
-	irq_set_chained_handler_and_data(irq, neponset_irq_handler, d);
 
 	/* Disable GPIO 0/1 drivers so the buttons work on the Assabet */
 	writeb_relaxed(NCR_GP01_OFF, d->base + NCR_0);
@@ -337,6 +374,8 @@ static int neponset_probe(struct platform_device *dev)
 	gpiod_add_lookup_table(&neponset_uart3_gpio_table);
 	gpiod_add_lookup_table(&neponset_pcmcia_table);
 
+	neponset_init_enet(&dev->dev, d);
+
 	/*
 	 * We would set IRQ_GPIO25 to be a wake-up IRQ, but unfortunately
 	 * something on the Neponset activates this IRQ on sleep (eth?)
@@ -370,9 +409,7 @@ static int neponset_probe(struct platform_device *dev)
  err_irq_alloc:
  err_id:
 	iounmap(d->base);
- err_ioremap:
-	kfree(d);
- err_alloc:
+ err:
 	return ret;
 }
 
@@ -386,6 +423,9 @@ static void neponset_remove(struct platform_device *dev)
 	if (!IS_ERR(d->smc91x))
 		platform_device_unregister(d->smc91x);
 
+	clkdev_drop(d->enet_osc_cl);
+	clk_hw_unregister_fixed_rate(d->enet_osc_ck);
+
 	gpiod_remove_lookup_table(&neponset_pcmcia_table);
 	gpiod_remove_lookup_table(&neponset_uart3_gpio_table);
 	gpiod_remove_lookup_table(&neponset_uart1_gpio_table);
@@ -394,7 +434,6 @@ static void neponset_remove(struct platform_device *dev)
 	irq_free_descs(d->irq_base, NEP_IRQ_NR);
 	nep = NULL;
 	iounmap(d->base);
-	kfree(d);
 }
 
 #ifdef CONFIG_PM_SLEEP
diff --git a/drivers/clk/Makefile b/drivers/clk/Makefile
index f793a16cad40..04f727081e23 100644
--- a/drivers/clk/Makefile
+++ b/drivers/clk/Makefile
@@ -40,6 +40,7 @@ obj-$(CONFIG_COMMON_CLK_ASPEED)		+= clk-aspeed.o
 obj-$(CONFIG_MACH_ASPEED_G6)		+= clk-ast2600.o
 obj-$(CONFIG_ARCH_HIGHBANK)		+= clk-highbank.o
 obj-$(CONFIG_CLK_HSDK)			+= clk-hsdk-pll.o
+obj-$(CONFIG_SA1100_H3600)		+= clk-ipaq.o
 obj-$(CONFIG_COMMON_CLK_K210)		+= clk-k210.o
 obj-$(CONFIG_LMK04832)			+= clk-lmk04832.o
 obj-$(CONFIG_COMMON_CLK_LAN966X)	+= clk-lan966x.o
diff --git a/drivers/clk/clk-gpio.c b/drivers/clk/clk-gpio.c
index 5b114043771d..f53df89940d4 100644
--- a/drivers/clk/clk-gpio.c
+++ b/drivers/clk/clk-gpio.c
@@ -28,26 +28,6 @@
  * parent - fixed parent.  No clk_set_parent support
  */
 
-/**
- * struct clk_gpio - gpio gated clock
- *
- * @hw:		handle between common and hardware-specific interfaces
- * @gpiod:	gpio descriptor
- *
- * Clock with a gpio control for enabling and disabling the parent clock
- * or switching between two parents by asserting or deasserting the gpio.
- *
- * Implements .enable, .disable and .is_enabled or
- * .get_parent, .set_parent and .determine_rate depending on which clk_ops
- * is used.
- */
-struct clk_gpio {
-	struct clk_hw	hw;
-	struct gpio_desc *gpiod;
-};
-
-#define to_clk_gpio(_hw) container_of(_hw, struct clk_gpio, hw)
-
 static int clk_gpio_gate_enable(struct clk_hw *hw)
 {
 	struct clk_gpio *clk = to_clk_gpio(hw);
@@ -71,11 +51,12 @@ static int clk_gpio_gate_is_enabled(struct clk_hw *hw)
 	return gpiod_get_value(clk->gpiod);
 }
 
-static const struct clk_ops clk_gpio_gate_ops = {
+const struct clk_ops clk_gpio_gate_ops = {
 	.enable = clk_gpio_gate_enable,
 	.disable = clk_gpio_gate_disable,
 	.is_enabled = clk_gpio_gate_is_enabled,
 };
+EXPORT_SYMBOL_GPL(clk_gpio_gate_ops);
 
 static int clk_sleeping_gpio_gate_prepare(struct clk_hw *hw)
 {
@@ -130,49 +111,67 @@ static int clk_gpio_mux_set_parent(struct clk_hw *hw, u8 index)
 	return 0;
 }
 
-static const struct clk_ops clk_gpio_mux_ops = {
+const struct clk_ops clk_gpio_mux_ops = {
 	.get_parent = clk_gpio_mux_get_parent,
 	.set_parent = clk_gpio_mux_set_parent,
 	.determine_rate = __clk_mux_determine_rate,
 };
+EXPORT_SYMBOL_GPL(clk_gpio_mux_ops);
 
-static struct clk_hw *clk_register_gpio(struct device *dev, u8 num_parents,
-					struct gpio_desc *gpiod,
-					const struct clk_ops *clk_gpio_ops)
+static struct clk_hw *clk_register_gpio(struct device *dev, const char *name,
+		const char * const *parent_names, u8 num_parents, struct gpio_desc *gpiod,
+		unsigned long flags, const struct clk_ops *clk_gpio_ops)
 {
 	struct clk_gpio *clk_gpio;
 	struct clk_hw *hw;
 	struct clk_init_data init = {};
 	int err;
-	const struct clk_parent_data gpio_parent_data[] = {
-		{ .index = 0 },
-		{ .index = 1 },
-	};
 
-	clk_gpio = devm_kzalloc(dev, sizeof(*clk_gpio),	GFP_KERNEL);
+	if (dev)
+		clk_gpio = devm_kzalloc(dev, sizeof(*clk_gpio),	GFP_KERNEL);
+	else
+		clk_gpio = kzalloc(sizeof(*clk_gpio), GFP_KERNEL);
+
 	if (!clk_gpio)
 		return ERR_PTR(-ENOMEM);
 
-	init.name = dev->of_node->name;
+	init.name = name;
 	init.ops = clk_gpio_ops;
-	init.parent_data = gpio_parent_data;
+	init.flags = flags;
+	init.parent_names = parent_names;
 	init.num_parents = num_parents;
-	init.flags = CLK_SET_RATE_PARENT;
 
 	clk_gpio->gpiod = gpiod;
 	clk_gpio->hw.init = &init;
 
 	hw = &clk_gpio->hw;
-	err = devm_clk_hw_register(dev, hw);
-	if (err)
-		return ERR_PTR(err);
+	if (dev)
+		err = devm_clk_hw_register(dev, hw);
+	else
+		err = clk_hw_register(NULL, hw);
+
+	if (!err)
+		return hw;
+
+	if (!dev) {
+		kfree(clk_gpio);
+	}
 
-	return hw;
+	return ERR_PTR(err);
 }
 
-static struct clk_hw *clk_hw_register_gpio_gate(struct device *dev,
-						int num_parents,
-						struct gpio_desc *gpiod)
+/**
+ * clk_hw_register_gpio_gate - register a gpio clock gate with the clock
+ * framework
+ * @dev: device that is registering this clock
+ * @name: name of this clock
+ * @parent_name: name of this clock's parent
+ * @gpiod: gpio descriptor to gate this clock
+ * @flags: clock flags
+ */
+struct clk_hw *clk_hw_register_gpio_gate(struct device *dev, const char *name,
+		const char *parent_name, struct gpio_desc *gpiod,
+		unsigned long flags)
 {
 	const struct clk_ops *ops;
 
@@ -181,36 +180,88 @@ static struct clk_hw *clk_hw_register_gpio_gate(struct device *dev,
 	else
 		ops = &clk_gpio_gate_ops;
 
-	return clk_register_gpio(dev, num_parents, gpiod, ops);
+	return clk_register_gpio(dev, name,
+			(parent_name ? &parent_name : NULL),
+			(parent_name ? 1 : 0), gpiod, flags, ops);
 }
+EXPORT_SYMBOL_GPL(clk_hw_register_gpio_gate);
 
-static struct clk_hw *clk_hw_register_gpio_mux(struct device *dev,
-					       struct gpio_desc *gpiod)
+struct clk *clk_register_gpio_gate(struct device *dev, const char *name,
+		const char *parent_name, struct gpio_desc *gpiod,
+		unsigned long flags)
 {
-	return clk_register_gpio(dev, 2, gpiod, &clk_gpio_mux_ops);
+	struct clk_hw *hw;
+
+	hw = clk_hw_register_gpio_gate(dev, name, parent_name, gpiod, flags);
+	if (IS_ERR(hw))
+		return ERR_CAST(hw);
+	return hw->clk;
 }
+EXPORT_SYMBOL_GPL(clk_register_gpio_gate);
+
+/**
+ * clk_hw_register_gpio_mux - register a gpio clock mux with the clock framework
+ * @dev: device that is registering this clock
+ * @name: name of this clock
+ * @parent_names: names of this clock's parents
+ * @num_parents: number of parents listed in @parent_names
+ * @gpiod: gpio descriptor to gate this clock
+ * @flags: clock flags
+ */
+struct clk_hw *clk_hw_register_gpio_mux(struct device *dev, const char *name,
+		const char * const *parent_names, u8 num_parents, struct gpio_desc *gpiod,
+		unsigned long flags)
+{
+	if (num_parents != 2) {
+		pr_err("mux-clock %s must have 2 parents\n", name);
+		return ERR_PTR(-EINVAL);
+	}
+
+	return clk_register_gpio(dev, name, parent_names, num_parents,
+			gpiod, flags, &clk_gpio_mux_ops);
+}
+EXPORT_SYMBOL_GPL(clk_hw_register_gpio_mux);
+
+struct clk *clk_register_gpio_mux(struct device *dev, const char *name,
+		const char * const *parent_names, u8 num_parents, struct gpio_desc *gpiod,
+		unsigned long flags)
+{
+	struct clk_hw *hw;
+
+	hw = clk_hw_register_gpio_mux(dev, name, parent_names, num_parents,
+			gpiod, flags);
+	if (IS_ERR(hw))
+		return ERR_CAST(hw);
+	return hw->clk;
+}
+EXPORT_SYMBOL_GPL(clk_register_gpio_mux);
 
 static int gpio_clk_driver_probe(struct platform_device *pdev)
 {
-	struct device *dev = &pdev->dev;
-	struct device_node *node = dev->of_node;
-	const char *gpio_name;
+	struct device_node *node = pdev->dev.of_node;
+	const char **parent_names, *gpio_name;
 	unsigned int num_parents;
 	struct gpio_desc *gpiod;
-	struct clk_hw *hw;
+	struct clk *clk;
 	bool is_mux;
 	int ret;
 
-	is_mux = of_device_is_compatible(node, "gpio-mux-clock");
-
 	num_parents = of_clk_get_parent_count(node);
-	if (is_mux && num_parents != 2) {
-		dev_err(dev, "mux-clock must have 2 parents\n");
-		return -EINVAL;
+	if (num_parents) {
+		parent_names = devm_kcalloc(&pdev->dev, num_parents,
+					    sizeof(char *), GFP_KERNEL);
+		if (!parent_names)
+			return -ENOMEM;
+
+		of_clk_parent_fill(node, parent_names, num_parents);
+	} else {
+		parent_names = NULL;
 	}
 
+	is_mux = of_device_is_compatible(node, "gpio-mux-clock");
+
 	gpio_name = is_mux ? "select" : "enable";
-	gpiod = devm_gpiod_get(dev, gpio_name, GPIOD_OUT_LOW);
+	gpiod = devm_gpiod_get(&pdev->dev, gpio_name, GPIOD_OUT_LOW);
 	if (IS_ERR(gpiod)) {
 		ret = PTR_ERR(gpiod);
 		if (ret == -EPROBE_DEFER)
@@ -224,13 +275,16 @@ static int gpio_clk_driver_probe(struct platform_device *pdev)
 	}
 
 	if (is_mux)
-		hw = clk_hw_register_gpio_mux(dev, gpiod);
+		clk = clk_register_gpio_mux(&pdev->dev, node->name,
+				parent_names, num_parents, gpiod, 0);
 	else
-		hw = clk_hw_register_gpio_gate(dev, num_parents, gpiod);
-	if (IS_ERR(hw))
-		return PTR_ERR(hw);
+		clk = clk_register_gpio_gate(&pdev->dev, node->name,
+				parent_names ?  parent_names[0] : NULL, gpiod,
+				CLK_SET_RATE_PARENT);
+	if (IS_ERR(clk))
+		return PTR_ERR(clk);
 
-	return devm_of_clk_add_hw_provider(dev, of_clk_hw_simple_get, hw);
+	return of_clk_add_provider(node, of_clk_src_simple_get, clk);
 }
 
 static const struct of_device_id gpio_clk_match_table[] = {
diff --git a/drivers/clk/clk-ipaq.c b/drivers/clk/clk-ipaq.c
new file mode 100644
index 000000000000..af48cdb7da53
--- /dev/null
+++ b/drivers/clk/clk-ipaq.c
@@ -0,0 +1,135 @@
+#include <linux/clk-provider.h>
+#include <linux/clkdev.h>
+#include <linux/gpio/consumer.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/platform_device.h>
+
+struct ipaq_audio_clk {
+	struct clk_hw clk;
+	struct clk_lookup *cl;
+	struct gpio_desc *gpios[2];
+};
+#define to_ipaq_audio_clk(x) container_of(x, struct ipaq_audio_clk, clk)
+
+static const char *clk_names[2] = { "clk0", "clk1" };
+
+static unsigned long ipaq_audio_clk_rates[] = {
+	12288000,
+	11289600,
+	4096000,
+	5624500,
+};
+
+static unsigned long ipaq_audio_clk_recalc_rate(struct clk_hw *hw,
+	unsigned long parent_rate)
+{
+	struct ipaq_audio_clk *ia = to_ipaq_audio_clk(hw);
+	unsigned int clk0 = !!gpiod_get_value(ia->gpios[0]);
+	unsigned int clk1 = !!gpiod_get_value(ia->gpios[1]);
+	unsigned int idx = clk1 * 2 + clk0;
+
+	return ipaq_audio_clk_rates[idx];
+}
+
+static long ipaq_audio_clk_round_rate(struct clk_hw *hw, unsigned long rate,
+	unsigned long *parent_rate)
+{
+	int i, best = -1;
+	long diff, best_diff = LONG_MAX;
+
+	for (i = 0; i < ARRAY_SIZE(ipaq_audio_clk_rates); i++) {
+		diff = ipaq_audio_clk_rates[i] - rate;
+		if (diff < 0)
+			diff = -diff;
+		if (diff < best_diff) {
+			best_diff = diff;
+			best = i;
+		}
+	}
+
+	return best == -1 ? -EINVAL : ipaq_audio_clk_rates[best];
+}
+
+static int ipaq_audio_clk_set_rate(struct clk_hw *hw, unsigned long rate,
+	unsigned long parent_rate)
+{
+	struct ipaq_audio_clk *ia = to_ipaq_audio_clk(hw);
+	DECLARE_BITMAP(values, 2) = { 0, };
+	int i;
+
+	for (i = 0; i < ARRAY_SIZE(ipaq_audio_clk_rates); i++) {
+		if (ipaq_audio_clk_rates[i] == rate) {
+			__assign_bit(0, values, !!(i & 1));
+			__assign_bit(1, values, !!(i & 2));
+
+			gpiod_set_array_value(2, ia->gpios, NULL, values);
+			return 0;
+		}
+	}
+	return -EINVAL;
+}
+
+static const struct clk_ops ipaq_audio_clk_ops = {
+	.recalc_rate = ipaq_audio_clk_recalc_rate,
+	.round_rate = ipaq_audio_clk_round_rate,
+	.set_rate = ipaq_audio_clk_set_rate,
+};
+
+static struct clk_init_data ipaq_audio_clk_init = {
+	.name = "ipaq-audio",
+	.ops = &ipaq_audio_clk_ops,
+};
+
+static int ipaq_audio_clk_probe(struct platform_device *pdev)
+{
+	struct ipaq_audio_clk *ia;
+	int i, ret;
+
+	ia = devm_kzalloc(&pdev->dev, sizeof(*ia), GFP_KERNEL);
+	if (!ia)
+		return -ENOMEM;
+
+	for (i = 0; i < ARRAY_SIZE(clk_names); i++) {
+		ia->gpios[i] = devm_gpiod_get(&pdev->dev, clk_names[i],
+					      GPIOD_OUT_LOW);
+		if (IS_ERR(ia->gpios[i]))
+			return PTR_ERR(ia->gpios[i]);
+	}
+
+	platform_set_drvdata(pdev, ia);
+
+	ia->clk.init = &ipaq_audio_clk_init;
+
+	ret = devm_clk_hw_register(&pdev->dev, &ia->clk);
+	if (ret)
+		return ret;
+
+	ia->cl = clkdev_hw_create(&ia->clk, "ext", "h3xxx-asoc");
+
+	return ia->cl ? 0 : -ENOMEM;
+}
+
+static int ipaq_audio_clk_remove(struct platform_device *pdev)
+{
+	struct ipaq_audio_clk *ia = platform_get_drvdata(pdev);
+
+	clkdev_drop(ia->cl);
+
+	return 0;
+}
+
+static struct platform_driver ipaq_audio_clk_driver = {
+	.probe = ipaq_audio_clk_probe,
+	.remove = ipaq_audio_clk_remove,
+	.driver = {
+		.name = "ipaq-audio-clk",
+	},
+};
+
+module_platform_driver(ipaq_audio_clk_driver);
+
+MODULE_AUTHOR("Russell King <rmk+kernel@armlinux.org.uk>");
+MODULE_DESCRIPTION("iPAQ Audio clock driver");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:ipaq-audio-clock");
diff --git a/drivers/mfd/ipaq-micro.c b/drivers/mfd/ipaq-micro.c
index c964ea6539aa..f5420e625bf9 100644
--- a/drivers/mfd/ipaq-micro.c
+++ b/drivers/mfd/ipaq-micro.c
@@ -88,6 +88,7 @@ static void micro_rx_msg(struct ipaq_micro *micro, u8 id, int len, u8 *data)
 	case MSG_BACKLIGHT:
 	case MSG_NOTIFY_LED:
 	case MSG_THERMAL_SENSOR:
+	case MSG_SPI_READ:
 	case MSG_BATTERY:
 		/* Handle synchronous messages */
 		if (micro->msg && micro->msg->id == id) {
